﻿program bbc;

{$APPTYPE CONSOLE}
{

                            ALL TOGETHER

                        8  ♜♞♝♛♚♝♞♜
                        7  ♟♟♟♟♟♟♟♟︎
                        6  . . . . . . . .
                        5  . . . . . . . .
                        4  . . . . . . . .
                        3  . . . . . . . .
                        2  ♙♙♙♙♙♙♙♙
                        1  ♖♘♗♕♔♗♘♖

                           a b c d e f g h
}
uses
  SysUtils,Windows,TypInfo;
type
    //указатель на структуру данных
    moves = ^move_list;
    //элемент односвязного списка
    move_list = record
    //ходы
    move:array[0..255] of integer;
    // move count
    count:integer;
    //указатель на следующий элемент
    next_move:moves;
end;
var
 add_move:moves;
type
    U64 = UInt64;
    TBoard_squares = (
    a8, b8, c8, d8, e8, f8, g8, h8,
    a7, b7, c7, d7, e7, f7, g7, h7,
    a6, b6, c6, d6, e6, f6, g6, h6,
    a5, b5, c5, d5, e5, f5, g5, h5,
    a4, b4, c4, d4, e4, f4, g4, h4,
    a3, b3, c3, d3, e3, f3, g3, h3,
    a2, b2, c2, d2, e2, f2, g2, h2,
    a1, b1, c1, d1, e1, f1, g1, h1
    );
    // sides to move (colors)
    TSide = (white, black, both);
    // bishop and rook
    Tbishop = (rook, bishop);
    // extract source square
    TExtract_source = (
    get_move_source,
    get_move_target,
    get_move_piece,
    get_move_promoted,
    get_move_capture,
    get_move_doubl,
    get_move_enpassan,
    get_move_castling
    );
    //Pawn
    TPawn_attacks=array[TSide,TBoard_squares] of U64;
    //прыгающие фигуры
    TChip_attacks=array[TBoard_squares] of U64;
    // encode pieces
    Tencode_pieces=( P_, N_, B_, R_, Q_, K_, p, n, b, r, q, k);
{// castling rights binary encoding
    рокеровка
/*

    bin  dec

   0001    1  white king can castle to the king side
   0010    2  white king can castle to the queen side
   0100    4  black king can castle to the king side
   1000    8  black king can castle to the queen side

   examples

   1111       both sides an castle both directions
   1001       black king => queen side
              white king => king side

*/}
   Tcastling = (wk = 1, wq = 2, bk = 4, bq = 8 );
var
{/**********************************\
 ==================================

            Chess board
 
 ==================================
\**********************************/

/*
                            WHITE PIECES


        Pawns                  Knights              Bishops
        
  8  0 0 0 0 0 0 0 0    8  0 0 0 0 0 0 0 0    8  0 0 0 0 0 0 0 0
  7  0 0 0 0 0 0 0 0    7  0 0 0 0 0 0 0 0    7  0 0 0 0 0 0 0 0
  6  0 0 0 0 0 0 0 0    6  0 0 0 0 0 0 0 0    6  0 0 0 0 0 0 0 0
  5  0 0 0 0 0 0 0 0    5  0 0 0 0 0 0 0 0    5  0 0 0 0 0 0 0 0
  4  0 0 0 0 0 0 0 0    4  0 0 0 0 0 0 0 0    4  0 0 0 0 0 0 0 0
  3  0 0 0 0 0 0 0 0    3  0 0 0 0 0 0 0 0    3  0 0 0 0 0 0 0 0
  2  1 1 1 1 1 1 1 1    2  0 0 0 0 0 0 0 0    2  0 0 0 0 0 0 0 0
  1  0 0 0 0 0 0 0 0    1  0 1 0 0 0 0 1 0    1  0 0 1 0 0 1 0 0

     a b c d e f g h       a b c d e f g h       a b c d e f g h


         Rooks                 Queens                 King

  8  0 0 0 0 0 0 0 0    8  0 0 0 0 0 0 0 0    8  0 0 0 0 0 0 0 0
  7  0 0 0 0 0 0 0 0    7  0 0 0 0 0 0 0 0    7  0 0 0 0 0 0 0 0
  6  0 0 0 0 0 0 0 0    6  0 0 0 0 0 0 0 0    6  0 0 0 0 0 0 0 0
  5  0 0 0 0 0 0 0 0    5  0 0 0 0 0 0 0 0    5  0 0 0 0 0 0 0 0
  4  0 0 0 0 0 0 0 0    4  0 0 0 0 0 0 0 0    4  0 0 0 0 0 0 0 0
  3  0 0 0 0 0 0 0 0    3  0 0 0 0 0 0 0 0    3  0 0 0 0 0 0 0 0
  2  0 0 0 0 0 0 0 0    2  0 0 0 0 0 0 0 0    2  0 0 0 0 0 0 0 0
  1  1 0 0 0 0 0 0 1    1  0 0 0 1 0 0 0 0    1  0 0 0 0 1 0 0 0

     a b c d e f g h       a b c d e f g h       a b c d e f g h


                            BLACK PIECES


        Pawns                  Knights              Bishops

  8  0 0 0 0 0 0 0 0    8  0 1 0 0 0 0 1 0    8  0 0 1 0 0 1 0 0
  7  1 1 1 1 1 1 1 1    7  0 0 0 0 0 0 0 0    7  0 0 0 0 0 0 0 0
  6  0 0 0 0 0 0 0 0    6  0 0 0 0 0 0 0 0    6  0 0 0 0 0 0 0 0
  5  0 0 0 0 0 0 0 0    5  0 0 0 0 0 0 0 0    5  0 0 0 0 0 0 0 0
  4  0 0 0 0 0 0 0 0    4  0 0 0 0 0 0 0 0    4  0 0 0 0 0 0 0 0
  3  0 0 0 0 0 0 0 0    3  0 0 0 0 0 0 0 0    3  0 0 0 0 0 0 0 0
  2  0 0 0 0 0 0 0 0    2  0 0 0 0 0 0 0 0    2  0 0 0 0 0 0 0 0
  1  0 0 0 0 0 0 0 0    1  0 0 0 0 0 0 0 0    1  0 0 0 0 0 0 0 0

     a b c d e f g h       a b c d e f g h       a b c d e f g h


         Rooks                 Queens                 King

  8  1 0 0 0 0 0 0 1    8  0 0 0 1 0 0 0 0    8  0 0 0 0 1 0 0 0
  7  0 0 0 0 0 0 0 0    7  0 0 0 0 0 0 0 0    7  0 0 0 0 0 0 0 0
  6  0 0 0 0 0 0 0 0    6  0 0 0 0 0 0 0 0    6  0 0 0 0 0 0 0 0
  5  0 0 0 0 0 0 0 0    5  0 0 0 0 0 0 0 0    5  0 0 0 0 0 0 0 0
  4  0 0 0 0 0 0 0 0    4  0 0 0 0 0 0 0 0    4  0 0 0 0 0 0 0 0
  3  0 0 0 0 0 0 0 0    3  0 0 0 0 0 0 0 0    3  0 0 0 0 0 0 0 0
  2  0 0 0 0 0 0 0 0    2  0 0 0 0 0 0 0 0    2  0 0 0 0 0 0 0 0
  1  0 0 0 0 0 0 0 0    1  0 0 0 0 0 0 0 0    1  0 0 0 0 0 0 0 0

     a b c d e f g h       a b c d e f g h       a b c d e f g h

}
 // piece bitboards
 bitboards_12:array[Tencode_pieces] of U64;
{
                             OCCUPANCIES
     White occupancy       Black occupancy       All occupancies

  8  0 0 0 0 0 0 0 0    8  1 1 1 1 1 1 1 1    8  1 1 1 1 1 1 1 1
  7  0 0 0 0 0 0 0 0    7  1 1 1 1 1 1 1 1    7  1 1 1 1 1 1 1 1
  6  0 0 0 0 0 0 0 0    6  0 0 0 0 0 0 0 0    6  0 0 0 0 0 0 0 0
  5  0 0 0 0 0 0 0 0    5  0 0 0 0 0 0 0 0    5  0 0 0 0 0 0 0 0
  4  0 0 0 0 0 0 0 0    4  0 0 0 0 0 0 0 0    4  0 0 0 0 0 0 0 0
  3  0 0 0 0 0 0 0 0    3  0 0 0 0 0 0 0 0    3  0 0 0 0 0 0 0 0
  2  1 1 1 1 1 1 1 1    2  0 0 0 0 0 0 0 0    2  1 1 1 1 1 1 1 1
  1  1 1 1 1 1 1 1 1    1  0 0 0 0 0 0 0 0    1  1 1 1 1 1 1 1 1
}
 // occupancy bitboards
 occupancies_3:array[TSide] of U64;
 // side to move
 side:TSide = both;
 // enpassant square
 enpassantInt:integer=-1;
 enpassant:TBoard_squares=a8;
 // castling rights
 castle:integer=0;
 // ASCII pieces
 ascii_pieces:array[0..11] of char = 'PNBRQKpnbrqk';
 // promoted pieces
 promoted_pieces:array[0..11] of char = ' nbrq  nbrq ';
 //===========================================
 bitboardU64:U64=0;
 block:U64=0;
 // pawn attacks table [side][square]
 pawn_attacks:TPawn_attacks;
 // knight attacks table [square]
 knight_attacks:TChip_attacks;
 // king attacks table [square]
 king_attacks:TChip_attacks;
 // bishop attack masks
 bishop_masks:array[TBoard_squares] of U64;
 // rook attack masks
 rook_masks:array[TBoard_squares] of U64;
 // bishop attacks table [square][occupancies]
 bishop_attacks:array[TBoard_squares,0..511] of U64;
 // rook attacks rable [square][occupancies]
 rook_attacks:array[TBoard_squares,0..4095] of U64;
 square:TBoard_squares;
 // pseudo random number state
 //cardinal - беззнаковое целое
 stateU32:cardinal = 1804289383;
const
{/*
        not A file
  8  0 1 1 1 1 1 1 1
  7  0 1 1 1 1 1 1 1
  6  0 1 1 1 1 1 1 1
  5  0 1 1 1 1 1 1 1
  4  0 1 1 1 1 1 1 1
  3  0 1 1 1 1 1 1 1
  2  0 1 1 1 1 1 1 1
  1  0 1 1 1 1 1 1 1
     a b c d e f g h
        not H file
  8  1 1 1 1 1 1 1 0
  7  1 1 1 1 1 1 1 0
  6  1 1 1 1 1 1 1 0
  5  1 1 1 1 1 1 1 0
  4  1 1 1 1 1 1 1 0
  3  1 1 1 1 1 1 1 0
  2  1 1 1 1 1 1 1 0
  1  1 1 1 1 1 1 1 0
     a b c d e f g h
       not HG file
  8  1 1 1 1 1 1 0 0
  7  1 1 1 1 1 1 0 0
  6  1 1 1 1 1 1 0 0
  5  1 1 1 1 1 1 0 0
  4  1 1 1 1 1 1 0 0
  3  1 1 1 1 1 1 0 0
  2  1 1 1 1 1 1 0 0
  1  1 1 1 1 1 1 0 0
     a b c d e f g h
       not AB file
  8  0 0 1 1 1 1 1 1
  7  0 0 1 1 1 1 1 1
  6  0 0 1 1 1 1 1 1
  5  0 0 1 1 1 1 1 1
  4  0 0 1 1 1 1 1 1
  3  0 0 1 1 1 1 1 1
  2  0 0 1 1 1 1 1 1
  1  0 0 1 1 1 1 1 1
     a b c d e f g h
*/}

// not A file constant
not_a_file:U64 = $FEFEFEFEFEFEFEFE;//18374403900871474942;
// not H file constant
not_h_file:U64 = $7F7F7F7F7F7F7F7F;//9187201950435737471;
// not HG file constant
not_hg_file:U64 =$3F3F3F3F3F3F3F3F;//4557430888798830399;
// not AB file constant
not_ab_file:U64 =$FCFCFCFCFCFCFCFC;//18229723555195321596;
square_to_coordinates: array [0..63]  of  string =  (
    'a8', 'b8', 'c8', 'd8', 'e8', 'f8', 'g8', 'h8',
    'a7', 'b7', 'c7', 'd7', 'e7', 'f7', 'g7', 'h7',
    'a6', 'b6', 'c6', 'd6', 'e6', 'f6', 'g6', 'h6',
    'a5', 'b5', 'c5', 'd5', 'e5', 'f5', 'g5', 'h5',
    'a4', 'b4', 'c4', 'd4', 'e4', 'f4', 'g4', 'h4',
    'a3', 'b3', 'c3', 'd3', 'e3', 'f3', 'g3', 'h3',
    'a2', 'b2', 'c2', 'd2', 'e2', 'f2', 'g2', 'h2',
    'a1', 'b1', 'c1', 'd1', 'e1', 'f1', 'g1', 'h1'
);
// bishop relevant occupancy bit count for every square on board
bishop_relevant_bits: array [TBoard_squares]  of  integer =(
    6, 5, 5, 5, 5, 5, 5, 6,
    5, 5, 5, 5, 5, 5, 5, 5, 
    5, 5, 7, 7, 7, 7, 5, 5,
    5, 5, 7, 9, 9, 7, 5, 5,
    5, 5, 7, 9, 9, 7, 5, 5,
    5, 5, 7, 7, 7, 7, 5, 5,
    5, 5, 5, 5, 5, 5, 5, 5,
    6, 5, 5, 5, 5, 5, 5, 6
);

// rook relevant occupancy bit count for every square on board
rook_relevant_bits: array [TBoard_squares]  of  integer =(
    12, 11, 11, 11, 11, 11, 11, 12,
    11, 10, 10, 10, 10, 10, 10, 11,
    11, 10, 10, 10, 10, 10, 10, 11,
    11, 10, 10, 10, 10, 10, 10, 11,
    11, 10, 10, 10, 10, 10, 10, 11,
    11, 10, 10, 10, 10, 10, 10, 11,
    11, 10, 10, 10, 10, 10, 10, 11,
    12, 11, 11, 11, 11, 11, 11, 12
);
// rook magic numbers
rook_magic_numbers:array[TBoard_squares] of U64  = (
$8A80104000800020,
$140002000100040,
$2801880A0017001,
$100081001000420,
$200020010080420,
$3001C0002010008,
$8480008002000100,
$2080088004402900,
$800098204000,
$2024401000200040,
$100802000801000,
$120800800801000,
$208808088000400,
$2802200800400,
$2200800100020080,
$801000060821100,
$80044006422000,
$100808020004000,
$12108A0010204200,
$140848010000802,
$481828014002800,
$8094004002004100,
$4010040010010802,
$20008806104,
$100400080208000,
$2040002120081000,
$21200680100081,
$20100080080080,
$2000A00200410,
$20080800400,
$80088400100102,
$80004600042881,
$4040008040800020,
$440003000200801,
$4200011004500,
$188020010100100,
$14800401802800,
$2080040080800200,
$124080204001001,
$200046502000484,
$480400080088020,
$1000422010034000,
$30200100110040,
$100021010009,
$2002080100110004,
$202008004008002,
$20020004010100,
$2048440040820001,
$101002200408200,
$40802000401080,
$4008142004410100,
$2060820C0120200,
$1001004080100,
$20C020080040080,
$2935610830022400,
$44440041009200,
$280001040802101,
$2100190040002085,
$80C0084100102001,
$4024081001000421,
$20030A0244872,
$12001008414402,
$2006104900A0804,
$1004081002402
);
// bishop magic numbers
bishop_magic_numbers:array[TBoard_squares] of U64  = (
$40040844404084,
$2004208A004208,
$10190041080202,
$108060845042010,
$581104180800210,
$2112080446200010,
$1080820820060210,
$3C0808410220200,
$4050404440404,
$21001420088,
$24D0080801082102,
$1020A0A020400,
$40308200402,
$4011002100800,
$401484104104005,
$801010402020200,
$400210C3880100,
$404022024108200,
$810018200204102,
$4002801A02003,
$85040820080400,
$810102C808880400,
$E900410884800,
$8002020480840102,
$220200865090201,
$2010100A02021202,
$152048408022401,
$20080002081110,
$4001001021004000,
$800040400A011002,
$E4004081011002,
$1C004001012080,
$8004200962A00220,
$8422100208500202,
$2000402200300C08,
$8646020080080080,
$80020A0200100808,
$2010004880111000,
$623000A080011400,
$42008C0340209202,
$209188240001000,
$400408A884001800,
$110400A6080400,
$1840060A44020800,
$90080104000041,
$201011000808101,
$1A2208080504F080,
$8012020600211212,
$500861011240000,
$180806108200800,
$4000020E01040044,
$300000261044000A,
$802241102020002,
$20906061210001,
$5A84841004010310,
$4010801011C04,
$A010109502200,
$4A02012000,
$500201010098B028,
$8040002811040900,
$28000010020204,
$6000020202D0240,
$8918844842082200,
$4010011029020020
);
{/**********************************\
 ==================================

           Random numbers

 ==================================
\**********************************/}
// generate 32-bit pseudo legal numbers
function  get_random_U32_number():cardinal;
begin
// XOR shift algorithm
stateU32:=stateU32 xor (stateU32 shl 13);
stateU32:=stateU32 xor (stateU32 shr 17);
stateU32:=stateU32 xor (stateU32 shl 5);
get_random_U32_number:=stateU32;
end;
// generate 64-bit pseudo legal numbers
function  get_random_U64_number():U64;
var
// define 4 random numbers
n1,n2,n3,n4:U64;
begin
n1:=0;n2:=0;n3:=0; n4:=0;
// init random numbers slicing 16 bits from MS1B side
n1:=(n1 or (get_random_U32_number())) and $FFFF;
n2:=(n2 or (get_random_U32_number())) and $FFFF;
n3:=(n3 or (get_random_U32_number())) and $FFFF;
n4:=(n4 or (get_random_U32_number())) and $FFFF;
// return random number
get_random_U64_number:=n1 or (n2 shl 16) or (n3 shl 32) or (n4 shl 48);
end;
// generate magic number candidate
function generate_magic_number():U64;
begin
  result:=get_random_U64_number() and get_random_U64_number() and get_random_U64_number();
end;
{/**********************************\
 ==================================
 
          Bit manipulations
 
 ==================================
\**********************************/}
// set/get/pop
function get_bit(bb:U64;const sq:integer):integer;
begin
get_bit:=(bb shr sq) and 1;
end;
procedure set_bit(var bb:U64;const sq:TBoard_squares);
begin
bb:=bb or ($8000000000000000 shr (63-Ord(sq)));
end;
procedure pop_bit(var bb:U64;const sq:TBoard_squares);
begin
if get_bit(bb,Ord(sq))>0 then bb:=bb xor ($8000000000000000 shr (63-Ord(sq)));
end;
// count bits within a bitboard (Brian Kernighan's way)
function count_bits(bb:U64):integer;
var
count:integer;
begin
    // bit counter
    count := 0;
    // consecutively reset least significant 1st bit
     while bb>0
     do  begin
         // increment count
         Inc(count);
         // reset least significant 1st bit
         bb := bb and (bb - 1);
         end;
count_bits:=count;
end;
// get least significant 1st bit index
function  get_ls1b_index(bb:U64):integer;
begin
  // make sure bitboard is not 0
 if bb<>0 then
 // count trailing bits before LS1B
 result:=count_bits((bb and (-bb))-1)
 // return illegal index
 else result:=-1;
end;
{/**********************************\
 ==================================
 
           Input & Output
 
 ==================================
\**********************************/}
// print bitboard
procedure print_bitboard(bb:U64);
var
rank_,file_,sq:integer;
begin
Writeln('');
  // loop over board ranks
  for rank_ := 0 to 7 do  begin
        // loop over board files
        for file_ := 0 to 7 do  begin
           // convert file & rank into square index
           sq:=rank_*8 + file_;
           //// print ranks
           if file_ = 0 then begin
           Write(8 - rank_);Write(' ');
           end;
           Write(' ');
           // print bit state (either 1 or 0)
           Write(get_bit(bb,sq));
        end;
        // print new line every rank
        Writeln('');
  end;
  // print new line
  Writeln('');
  // print board files
  Writeln('   a b c d e f g h');
  Writeln('');
  // print bitboard as unsigned decimal number
  Write('bitboard = ',bb);
  Writeln('');
end;
// print board
procedure print_board();
var
rank_,file_,sq:integer;
bb_piece:Tencode_pieces;
flag:boolean;
begin
Writeln('');
  // loop over board ranks
  for rank_ := 0 to 7 do  begin
        // loop over board files
        for file_ := 0 to 7 do  begin
           // convert file & rank into square index
           sq:=rank_*8 + file_;
           //// print ranks
           if file_ = 0 then begin
           Write(8 - rank_);Write(' ');
           end;
           Write(' ');
           flag:=true;
               // loop over all piece bitboards
               for bb_piece := P_ to k do  begin
                 if get_bit(bitboards_12[bb_piece],sq)>0 then begin
                       Write(ascii_pieces[integer(bb_piece)]);
                       flag:=false;
                 end;
               end;
           if flag then   Write('.');
        end;
        // print new line every rank
        Writeln('');
  end;
  // print new line
  Writeln('');
  // print board files
  Writeln('   a b c d e f g h');
  Writeln('');
  Write('side      = ');
  //Write(GetEnumName(TypeInfo(TSide), ord(TSide(integer(side)))));
  //TSide = (white, black, both);
  if side=white then Write('white');
  if side=black then Write('black');
  Writeln('');
  Write('castle    = ');
  if (castle and integer(Tcastling(wk)))>0 then Write('K') else Write('-');
  if (castle and integer(Tcastling(wq)))>0 then Write('Q') else Write('-');
  if (castle and integer(Tcastling(bk)))>0 then Write('k') else Write('-');
  if (castle and integer(Tcastling(bq)))>0 then Write('q') else Write('-');
  Writeln('');
  Write('enpassant = ');
  if enpassantInt=-1 then Write('no') else begin
  //enpassant:=TBoard_squares(enpassantInt);
  Write(GetEnumName(TypeInfo(TBoard_squares), ord(enpassantInt)));
  end;
  Writeln('');
end;
// parse FEN string
function parse_fen(sfen:String):boolean;
var
// i,j - индекс массива
// len_fen - длина строки fen
// n64 - счетчик шахматных клеток (64 клетки)
// num - позиция символа в strN или strF
i,j,len_fen,n64,num:integer;
//строки для цифр из fen строки -  strN, фигур - strF, единичного символа - s01
strN,strF,s01,strA:string;
bt:Byte;
bb_piece:Tencode_pieces;
begin
 //если fen строка пустая, то ошибка fen строки
 result:=false;
 if sfen='' then exit;
// reset board position (bitboards)
bt:=0;
FillChar(bitboards_12, 12*SizeOf(UInt64), bt);
// reset occupancies (bitboards)
FillChar(occupancies_3, 3*SizeOf(UInt64), bt);
// reset game state variables
// side to move
side := black;
// enpassant square
enpassantInt:=-1;
enpassant:=a8;//заведомо ложное поле
// castling rights
castle:=0;
// инициализация строк для парсинга fen строки
 strN:='12345678';
 strF:='PNBRQKpnbrqk';
 strA:='abcdefgh';
//определяем длину fen строки
   len_fen:=length(sfen);
//сбрасываем счетчик
   n64:=-1;
//перебираем символы fen строки
      for i := 1 to len_fen do begin
      //берем один символ  fen строки на позиции i
      //возвращает подстроку строки sfen начинающуюся с индекса i длиной 1 символ
         s01:=copy(sfen,i,1);
      //возвр. позицию символа s01 в строке strN, если нет символа, то 0
      //сначала проверяем s01 - это цифра?
         num:=pos(s01,strN);
      //continue прерывает только выполнение текущей итерации,
      //текущего выполнения тела цикла
      //и передает управление на следующую итерацию.
         if s01='/' then continue;
      //если пробел заканчиваем парсинг   
         if s01=' ' then begin
         num:=pos(' ',sfen);
         sfen:=copy(sfen,num+1,len_fen-num);
             for j := 1 to length(sfen) do begin
               s01:=copy(sfen,j,1);
               if s01=' ' then continue;
               // side to move
               if s01='w' then begin side := white; continue;end;
               case Ord(sfen[j]) of
                    Ord('K'):begin castle:=castle or integer(wk);end;
                    Ord('Q'):begin castle:=castle or integer(wq);end;
                    Ord('k'):begin castle:=castle or integer(bk);end;
                    Ord('q'):begin castle:=castle or integer(bq);end;
               end;
               if (((sfen[j] >= 'a') and (sfen[j] <= 'h'))  and ((sfen[j+1] = '3') or (sfen[j+1] = '6'))) then begin
                  enpassantInt:=pos(copy(sfen,j,1),strA)-1+8*(8-(pos(copy(sfen,j+1,1),strN)));
                  enpassant:=TBoard_squares(enpassantInt);
               end;
              // Writeln(sfen[j]);
              end;
         break;
         end;
      //увеличиваем счетчик шахматных клеток n64
      // если num=0, значит символ s01 фигура
         if num=0 then begin
              Inc(n64);
      // иначе цифра
         end else begin
              n64:=n64+num;
         end;
      //если клеток больше 64(0..63), то ошибка fen строки
         if n64>63 then exit;
      //проверяем s01 - это символ фигуры?
          num:=pos(s01,strF);
      //если num - это не допустимый символ,  то ошибка fen строки
          if ((num=0) and (pos(s01,strN)=0))then exit;
      //заносим фигуры в массивы    
          if num>0 then begin
           //Tencode_pieces=( P_, N_, B_, R_, Q_, K_, p, n, b, r, q, k);
          set_bit(bitboards_12[Tencode_pieces(num-1)],TBoard_squares(n64));
          end;
      end;//for
//если клеток не равно 64(0..63), то ошибка fen строки
  if n64<>63 then exit;
//если королей не равно 1, то ошибка fen строки
if count_bits(bitboards_12[K_])<>1 then exit;
if count_bits(bitboards_12[k])<>1 then exit;
               // loop over white  pieces bitboardsoop over all piece bitboards
               for bb_piece := P_ to K_ do
               // populate white occupancy bitboard
               occupancies_3[white] := occupancies_3[white] or bitboards_12[bb_piece];
               // loop over black pieces bitboardsoop over all piece bitboards
               for bb_piece := p to k do
               // populate black occupancy bitboard
               occupancies_3[black] := occupancies_3[black] or bitboards_12[bb_piece];
               // init all occupancies
               occupancies_3[both] := occupancies_3[both] or occupancies_3[white] or occupancies_3[black];
//парсинг завершен успешно
//print_board();
result:=true;
end;
{/**********************************\
 ==================================

              Attacks

 ==================================
\**********************************/}
// generate pawn attacks
function mask_pawn_attacks(sd:TSide;square:TBoard_squares):U64;
var
attacks,bitboard:U64;
begin
// result attacks bitboard
attacks := 0;
// piece bitboard
bitboard := 0;
// set piece on board
set_bit(bitboard, square);
    // white pawns
    if (sd=white) then begin
      if ((bitboard shr 7) and not_a_file)>0 then  attacks:=attacks or (bitboard shr 7);
      if ((bitboard shr 9) and not_h_file)>0 then  attacks:=attacks or (bitboard shr 9);
    end
    // black pawns
    else  begin
      if ((bitboard shl 7) and not_h_file)>0 then  attacks:=attacks or (bitboard shl 7);
      if ((bitboard shl 9) and not_a_file)>0 then  attacks:=attacks or (bitboard shl 9);
    end;
// return attack map
mask_pawn_attacks:=attacks;
end;
// generate knight attacks
function  mask_knight_attacks(square:TBoard_squares):U64;
var
attacks,bitboard:U64;
begin
// result attacks bitboard
attacks := 0;
// piece bitboard
bitboard := 0;
// set piece on board
set_bit(bitboard, square);
    // generate knight attacks
    if ((bitboard shr 17) and not_h_file)>0 then  attacks:=attacks or (bitboard shr 17);
    if ((bitboard shr 15) and not_a_file)>0 then  attacks:=attacks or (bitboard shr 15);
    if ((bitboard shr 10) and not_hg_file)>0 then  attacks:=attacks or (bitboard shr 10);
    if ((bitboard shr 6) and not_ab_file)>0 then  attacks:=attacks or (bitboard shr 6);
    if ((bitboard shl 17) and not_a_file)>0 then  attacks:=attacks or (bitboard shl 17);
    if ((bitboard shl 15) and not_h_file)>0 then  attacks:=attacks or (bitboard shl 15);
    if ((bitboard shl 10) and not_ab_file)>0 then  attacks:=attacks or (bitboard shl 10);
    if ((bitboard shl 6) and not_hg_file)>0 then  attacks:=attacks or (bitboard shl 6);
// return attack map
mask_knight_attacks:=attacks;
end;
// generate king attacks
function  mask_king_attacks(square:TBoard_squares):U64;
var
attacks,bitboard:U64;
begin
// result attacks bitboard
attacks := 0;
// piece bitboard
bitboard := 0;
// set piece on board
set_bit(bitboard, square);
    // generate king attacks
    if (bitboard shr 8)>0 then  attacks:=attacks or (bitboard shr 8);
    if ((bitboard shr 9) and not_h_file)>0 then  attacks:=attacks or (bitboard shr 9);
    if ((bitboard shr 1) and not_h_file)>0 then  attacks:=attacks or (bitboard shr 1);
    if ((bitboard shr 7) and not_a_file)>0 then  attacks:=attacks or (bitboard shr 7);
    if (bitboard shl 8)>0 then  attacks:=attacks or (bitboard shl 8);
    if ((bitboard shl 9) and not_a_file)>0 then  attacks:=attacks or (bitboard shl 9);
    if ((bitboard shl 1) and not_a_file)>0 then  attacks:=attacks or (bitboard shl 1);
    if ((bitboard shl 7) and not_h_file)>0 then  attacks:=attacks or (bitboard shl 7);
// return attack map
mask_king_attacks:=attacks;
end;
//урок 6-masking relevant bishop occupancy bits to form a key for MAGIC BITBOARDS
// mask bishop attacks
function   mask_bishop_attacks(square:TBoard_squares):U64;
var
attacks,n:U64;
r,f,tr,tf:integer;
begin
n:=1;
// result attacks bitboard
attacks := 0;
    // init target rank & files
    tr := Ord(square) div 8;//целочисленное деление
    tf := Ord(square) mod 8;//остаток от деления
    // mask relevant bishop occupancy bits
    f:=tf+1;
    for r:=tr+1 to 6 do begin
       if f>6 then break;
       attacks := attacks or (n shl (r*8+f));
       Inc(f);
    end;
    f:=tf+1;
    for r:=tr-1 downto 1 do begin
       if f>6 then break;
       attacks := attacks or (n shl (r*8+f));
       Inc(f);
    end;
    f:=tf-1;
    for r:=tr+1 to 6 do begin
       if f<1 then break;
       attacks := attacks or (n shl (r*8+f));
       Dec(f);
    end;
    f:=tf-1;
    for r:=tr-1 downto 1 do begin
       if f<1 then break;
       attacks := attacks or (n shl (r*8+f));
       Dec(f);
    end;
// return attack map
mask_bishop_attacks:=attacks;
end;
//урок 7-masking relevant ROOK OCCUPANCY BITS to form a key for MAGIC BITBOARDS
// mask rook attacks
function   mask_rook_attacks(square:TBoard_squares):U64;
var
attacks,n:U64;
r,f,tr,tf:integer;
begin
n:=1;
// result attacks bitboard
attacks := 0;
    // init target rank & files
    tr := Ord(square) div 8;//целочисленное деление
    tf := Ord(square) mod 8;//остаток от деления
    // mask relevant bishop occupancy bits
    for r:=tr+1 to 6 do attacks := attacks or (n shl (r*8+tf));
    for r:=tr-1 downto 1 do attacks := attacks or (n shl (r*8+tf));
    for f:=tf+1 to 6 do attacks := attacks or (n shl (tr*8+f));
    for f:=tf-1 downto 1 do attacks := attacks or (n shl (tr*8+f));
// return attack map
mask_rook_attacks:=attacks;
end;
//урок 8-generating SLIDER PIECES ATTACKS on the fly for MAGIC BITBOARD purposes
// generate bishop attacks on the fly
function  bishop_attacks_on_the_fly(square:TBoard_squares;blk:U64):U64;
var
attacks,n:U64;
r,f,tr,tf:integer;
begin
n:=1;
// result attacks bitboard
attacks := 0;
    // init target rank & files
    tr := Ord(square) div 8;//целочисленное деление
    tf := Ord(square) mod 8;//остаток от деления
    // generate bishop atacks
    f:=tf+1;
    for r:=tr+1 to 7 do begin
       if f>7 then break;
       attacks := attacks or (n shl (r*8+f));
       if ((n shl (r*8+f)) and blk)>0 then  break;
       Inc(f);
    end;
        f:=tf+1;
    for r:=tr-1 downto 0 do begin
       if f>7 then break;
       attacks := attacks or (n shl (r*8+f));
       if ((n shl (r*8+f)) and blk)>0 then  break;
       Inc(f);
    end;
    f:=tf-1;
    for r:=tr+1 to 7 do begin
       if f<0 then break;
       attacks := attacks or (n shl (r*8+f));
       if ((n shl (r*8+f)) and blk)>0 then  break;
       Dec(f);
    end;
    f:=tf-1;
    for r:=tr-1 downto 0 do begin
       if f<0 then break;
       attacks := attacks or (n shl (r*8+f));
       if ((n shl (r*8+f)) and blk)>0 then  break;
       Dec(f);
    end;
// return attack map
bishop_attacks_on_the_fly:=attacks;
end;
// generate rook attacks on the fly
function  rook_attacks_on_the_fly(square:TBoard_squares;blk:U64):U64;
var
attacks,n:U64;
r,f,tr,tf:integer;
begin
n:=1;
// result attacks bitboard
attacks := 0;
    // init target rank & files
    tr := Ord(square) div 8;//целочисленное деление
    tf := Ord(square) mod 8;//остаток от деления
    // generate rook attacks
    for r:=tr+1 to 7 do begin
    attacks := attacks or (n shl (r*8+tf));
    if ((n shl (r*8+tf)) and blk)>0 then  break;
    end;
    for r:=tr-1 downto 0 do begin
    attacks := attacks or (n shl (r*8+tf));
    if ((n shl (r*8+tf)) and blk)>0 then  break;
    end;
    for f:=tf+1 to 7 do begin
    attacks := attacks or (n shl (tr*8+f));
    if ((n shl (tr*8+f)) and blk)>0 then  break;
    end;
    for f:=tf-1 downto 0 do begin
    attacks := attacks or (n shl (tr*8+f));
    if ((n shl (tr*8+f)) and blk)>0 then  break;
    end;
// return attack map
rook_attacks_on_the_fly:=attacks;
end;
// init leaper pieces attacks
procedure init_leapers_attacks();
var
square:TBoard_squares;
begin
    // loop over 64 board squares
    for square := a8 to h1 do  begin
//урок 3-generating pre-calculated PAWN ATTACK tables
       // init pawn attacks
       pawn_attacks[white][square] := mask_pawn_attacks(white,square);
       pawn_attacks[black][square] := mask_pawn_attacks(black,square);
//урок 4-generating pre-calculated KNIGHT ATTACK table
       // init knight attacks
       knight_attacks[square] := mask_knight_attacks(square);
//урок 5-generating pre-calculated KING ATTACK tables
       // init king attacks
       king_attacks[square] := mask_king_attacks(square);
    end;
end;
// set occupancies
//перебираем по очереди биты в attack_mask
//испр. ошибка - было -var attack_mask:U64, стало-attack_mask:U64
function set_occupancy(index,bits_in_mask:integer;attack_mask:U64):U64;
var
occupancy,n:U64;
count:integer;
square_:TBoard_squares;
begin
n:=1;
// occupancy map
occupancy:=0;
            // loop over the range of bits within attack mask
            for count:=0 to bits_in_mask-1 do begin
               // get LS1B index of attacks mask
               square_:=TBoard_squares(get_ls1b_index(attack_mask));
               // pop LS1B in attack map
               pop_bit(attack_mask,square_);
               // make sure occupancy is on board
               if (index and (n shl count))>0 then
                   occupancy:=occupancy or (n shl integer(square_));
            end;
set_occupancy:=occupancy;
end;
{/**********************************\
 ==================================

               Magics

 ==================================
\**********************************/}
// find appropriate magic number
function find_magic_number(square:TBoard_squares;relevant_bits:integer;bishop_flag:Tbishop):U64;
//function find_magic_number():U64;
var
// init occupancies
occupancies:array[0..4095] of U64;
// init attack tables
attacks:array[0..4095] of U64;
// init used attacks
used_attacks:array[0..4095] of U64;
n:Byte;
// init attack mask for a current piece
attack_mask:U64;
// init occupancy indicies
occupancy_indicies:integer;
magic_index:integer;
index,fail,random_count:integer;
magic_number:U64;
//memset
//https://metanit.com/c/tutorial/8.3.php?ysclid=ldc20xz850854644891
begin
attack_mask:=0;
 // init attack mask for a current piece
 if bishop_flag=bishop then attack_mask:=mask_bishop_attacks(square)
                       else attack_mask:=mask_rook_attacks(square);
 // init occupancy indicies  напр. ладья на a1 - rook_relevant_bits: array [ ] = 12
 // 1 shl 12 = 4096
 occupancy_indicies:=1 shl relevant_bits;
 // loop over occupancy indicies
 for index:=0 to occupancy_indicies-1 do begin
    // init occupancies
    occupancies[index] := set_occupancy(index,relevant_bits,attack_mask);
    // init attacks
    if bishop_flag=bishop then attacks[index]:= bishop_attacks_on_the_fly(square, occupancies[index])
                          else attacks[index]:= rook_attacks_on_the_fly(square, occupancies[index]);
 end;
 // test magic numbers loop
 n:=0;
 for random_count:= 0 to 100000000 do begin
     // generate magic number candidate
     magic_number := generate_magic_number();
     // skip inappropriate magic numbers
     if (count_bits((attack_mask * magic_number) and $FF00000000000000) < 6) then continue;
//http://www.delphibasics.ru/FillChar.php
// procedure FillChar ( var Buffer; FillCount : Integer; FillValue : Byte ) ;
{Процедура FillChar заполняет раздел памяти Buffer
тем же самым байтом или символом FillValue FillCount раз.
Это используется, преимущественно, для инициализирования массивов чисел.}
   // Теперь заполняем массив used_attacks значением 0
   // UInt64 - 8 байт
   FillChar(used_attacks, 4096*SizeOf(UInt64), n);
   fail := 0;
   for index:=0 to occupancy_indicies-1 do begin
      // init magic index
      magic_index := integer((occupancies[index] * magic_number) shr (64 - relevant_bits));
      {Writeln('occupancies[',index,'] = ',occupancies[index]);
      Writeln('magic_index = ',magic_index);
      Writeln('magic_number = ',magic_number);
      Readln;}
            // if magic index works
            if (used_attacks[magic_index] = 0) then
                // init used attacks
                used_attacks[magic_index] := attacks[index]
            // otherwise
            else if (used_attacks[magic_index] <> attacks[index])  then  begin
                // magic index doesn't work
                 fail := 1;break;
            end;
    end;
// if magic number works
if (fail=0) then  begin
// return it
result:=magic_number;
exit;
end;
 end;
   // if magic number doesn't work
   Writeln(' Magic number fails! ');
   result:=0;
end;
// init magic numbers
procedure init_magic_numbers();
var
tem64:U64;
temp32:integer;
begin
 // loop over 64 board squares
  for square := a8 to h1 do  begin
    tem64:=find_magic_number(square,rook_relevant_bits[square],rook);
    Write('0x');Write(Format('%x',[tem64]));Write('ULL');
    //Write('$');Write(Format('%x',[tem64]));Write(',');
    Writeln('');
    //Write(tem64);
    //Readln;
  end;
  //Writeln('====================');
  for square := a8 to h1 do  begin
    tem64:=find_magic_number(square,bishop_relevant_bits[square],bishop);
    Write('0x');Write(Format('%x',[tem64]));Write('ULL');
    //Write('$');Write(Format('%x',[tem64]));Write(',');
    Writeln('');
    //Write(tem64);
    //Readln;
  end;
end;
// init slider piece's attack tables
procedure init_sliders_attacks(bishop_flag:Tbishop);
var
// init current mask
attack_mask:U64;
// init current occupancy variation
occupancy:U64;
// init relevant occupancy bit count
relevant_bits_count:integer;
// init occupancy indicies
occupancy_indicies:integer;
magic_index:integer;
index:integer;
begin
    // loop over 64 board squares
    for square := a8 to h1 do  begin
        // init bishop & rook masks
        bishop_masks[square] := mask_bishop_attacks(square);
        rook_masks[square] := mask_rook_attacks(square);
        // init current mask
        if bishop_flag=bishop then  attack_mask:=bishop_masks[square]
                              else  attack_mask:=rook_masks[square];
        // init relevant occupancy bit count
        relevant_bits_count := count_bits(attack_mask);
        // init occupancy indicies
        occupancy_indicies := 1 shl relevant_bits_count;
        // loop over occupancy indicies
        for index:=0 to occupancy_indicies-1 do begin
           // bishop
           if bishop_flag=bishop then begin
// init current occupancy variation
occupancy := set_occupancy(index, relevant_bits_count, attack_mask);
// init magic index
magic_index := integer((occupancy * bishop_magic_numbers[square]) shr (64 - bishop_relevant_bits[square]));
// init bishop attacks
bishop_attacks[square][magic_index] := bishop_attacks_on_the_fly(square, occupancy);
           end
           // rook
           else begin
// init current occupancy variation
occupancy := set_occupancy(index, relevant_bits_count, attack_mask);
// init magic index
magic_index := integer((occupancy * rook_magic_numbers[square]) shr (64 - rook_relevant_bits[square]));
// init bishop attacks
rook_attacks[square][magic_index] := rook_attacks_on_the_fly(square, occupancy);
           end;
        end;
    end;
end;
// get bishop attacks
function get_bishop_attacks(square:TBoard_squares;occupancy:U64):U64;
begin
occupancy:=occupancy and bishop_masks[square];
occupancy:=occupancy * bishop_magic_numbers[square];
occupancy:=occupancy shr (64 - bishop_relevant_bits[square]);
// return bishop attacks
result:=bishop_attacks[square][occupancy];
end;
// get rook attacks
function get_rook_attacks(square:TBoard_squares;occupancy:U64):U64;
begin
occupancy:=occupancy and rook_masks[square];
occupancy:=occupancy * rook_magic_numbers[square];
occupancy:=occupancy shr (64 - rook_relevant_bits[square]);
// return bishop attacks
result:=rook_attacks[square][occupancy];
end;
// get queen attacks
function get_queen_attacks(square:TBoard_squares;occupancy:U64):U64;
begin
result:=get_bishop_attacks(square,occupancy) or get_rook_attacks(square,occupancy);
end;
{/**********************************\
 ==================================

              Init all

 ==================================
\**********************************/}
// init all variables
procedure init_all();
var
piece:Tencode_pieces;
begin
    // init leaper pieces attacks
    init_leapers_attacks();
    // init slider pieces attacks
    init_sliders_attacks(bishop);
    init_sliders_attacks(rook);
    // init magic numbers
    //init_magic_numbers();
    for square := a8 to h1 do  begin
        for piece := P_ to k do  begin
           pop_bit(bitboards_12[piece],square);
        end;
    end;
end;
{
/**********************************\
 ==================================
 
           Move generator
 
 ==================================
\**********************************/
}
// is square current given attacked by the current given side
function is_square_attacked(square:TBoard_squares;sd:TSide):integer;
begin
// attacked by white pawns
if ((sd = white) and ((pawn_attacks[black][square] and bitboards_12[P_])>0)) then
begin
  result:=1;exit;
end;
// attacked by black pawns
if ((sd = black) and ((pawn_attacks[white][square] and bitboards_12[p])>0)) then
begin
  result:=1;exit;
end;
// attacked by knights
if ((sd = white) and ((knight_attacks[square] and bitboards_12[N_])>0)) then
begin
  result:=1;exit;
end;
if ((sd = black) and ((knight_attacks[square] and bitboards_12[n])>0)) then
begin
  result:=1;exit;
end;
// attacked by bishops
if ((sd = white) and ((get_bishop_attacks(square, occupancies_3[both]) and bitboards_12[B_])>0)) then
begin
  result:=1;exit;
end;
if ((sd = black) and ((get_bishop_attacks(square, occupancies_3[both]) and bitboards_12[b])>0)) then
begin
  result:=1;exit;
end;
// attacked by rooks
if ((sd = white) and ((get_rook_attacks(square, occupancies_3[both]) and bitboards_12[R_])>0)) then
begin
  result:=1;exit;
end;
if ((sd = black) and ((get_rook_attacks(square, occupancies_3[both]) and bitboards_12[r])>0)) then
begin
  result:=1;exit;
end;
// attacked by queens
if ((sd = white) and ((get_queen_attacks(square, occupancies_3[both]) and bitboards_12[Q_])>0)) then
begin
  result:=1;exit;
end;
if ((sd = black) and ((get_queen_attacks(square, occupancies_3[both]) and bitboards_12[q])>0)) then
begin
  result:=1;exit;
end;
// attacked by kings
if ((sd = white) and ((king_attacks[square] and bitboards_12[K_])>0)) then
begin
  result:=1;exit;
end;
if ((sd = black) and ((king_attacks[square] and bitboards_12[k])>0)) then
begin
  result:=1;exit;
end;
  result:=0;
end;
// print attacked squares
procedure print_attacked_squares(sd:TSide);
var
rank_,file_,sq:integer;
begin
Writeln('');
  // loop over board ranks
  for rank_ := 0 to 7 do  begin
        // loop over board files
        for file_ := 0 to 7 do  begin
           // convert file & rank into square index
           sq:=rank_*8 + file_;
                      //// print ranks
           if file_ = 0 then begin
           Write(8 - rank_);Write(' ');
           end;
           Write(' ');
           // check whether current square is attacked or not
           Write(is_square_attacked(TBoard_squares(sq),sd));
        end;
        // print new line every rank
        Writeln('');
  end;
  // print new line
  Writeln('');
  // print board files
  Writeln('   a b c d e f g h');
  Writeln('');
end;
{/*
          binary move bits                               hexidecimal constants

    0000 0000 0000 0000 0011 1111    source square       $3f
    0000 0000 0000 1111 1100 0000    target square       $fc0
    0000 0000 1111 0000 0000 0000    piece               $f000
    0000 1111 0000 0000 0000 0000    promoted piece      $f0000
    0001 0000 0000 0000 0000 0000    capture flag        $100000
    0010 0000 0000 0000 0000 0000    double push flag    $200000
    0100 0000 0000 0000 0000 0000    enpassant flag      $400000
    1000 0000 0000 0000 0000 0000    castling flag       $800000
*/
}
// encode move
function encode_move(source,target:TBoard_squares;piece:Tencode_pieces; promoted,capture,double,enpassant,castling:integer):integer;
begin
encode_move:=integer(source) or (integer(target) shl 6) or
(integer(piece) shl 12) or (promoted shl 16) or
(capture shl 20) or (double shl 21) or (enpassant shl 22) or (castling shl 23);
end;
//get_move_source
function get_source(mv:integer;src:TExtract_source):integer;
begin
result:=0;
   case src of
     get_move_source:result:=mv and $3f;
     get_move_target:result:=(mv and $fc0) shr 6;
     get_move_piece:result:=(mv and $f000) shr 12;
     get_move_promoted:result:=(mv and $f0000) shr 16;
     get_move_capture:if (mv and $100000)>0 then result:=1;
     get_move_doubl:if (mv and $200000)>0 then result:=1;
     get_move_enpassan:if (mv and $400000)>0 then result:=1;
     get_move_castling:if (mv and $800000)>0 then result:=1;
   end;
end;
// print move (for UCI purposes)
procedure print_move(mv:integer);
begin
  if mv=0 then begin
    Writeln('Пустой ход ');
    exit;
  end;
  Write(square_to_coordinates[integer(get_source(mv,get_move_source))]);
  Write(square_to_coordinates[integer(get_source(mv,get_move_target))]);
  Writeln(promoted_pieces[get_source(mv,get_move_promoted)]);
end;
// print move list
procedure print_move_list();
var
i:integer;
begin
if add_move=nil then begin
Writeln('Список ходов пуст ');
exit;
end;
    Writeln('   move    piece    capture    double    enpass    castling');
  for i := 0 to add_move^.count-1 do  begin
    Write('   ',square_to_coordinates[integer(get_source(add_move^.move[i],get_move_source))]);
    Write(square_to_coordinates[integer(get_source(add_move^.move[i],get_move_target))]);
    Write(promoted_pieces[get_source(add_move^.move[i],get_move_promoted)]);
    Write('     ',GetEnumName(TypeInfo(Tencode_pieces), ord(get_source(add_move^.move[i],get_move_piece))));
    Write('        ',get_source(add_move^.move[i],get_move_capture));
    Write('         ',get_source(add_move^.move[i],get_move_doubl));
    Write('         ',get_source(add_move^.move[i],get_move_enpassan));
    Writeln('          ',get_source(add_move^.move[i],get_move_castling));
  end;
    Writeln('Количество ходов ',add_move^.count);
end;
// generate all moves
procedure generate_moves();
var
piece :Tencode_pieces;
// define current piece's bitboard copy & it's attacks
attacks,bitboard,occupancies,enpassant_attacks,n1:U64;
// define source & target squares
source_square, target_square:TBoard_squares;
source_squareInt, target_squareInt,target_enpassantInt :integer;
count_move:integer;
begin
if add_move=nil then exit;
count_move:=0;
n1:=1;
     // loop over all the bitboards
      for piece := P_ to k do  begin
           // init piece bitboard copy
        bitboard := bitboards_12[piece];
        // generate white pawns & white king castling moves
        if (side = white) then begin
            //---------piece = P_-------------
            // pick up white pawn bitboards index
            if (piece = P_) then begin
               // loop over white pawns within white pawn bitboard
               while bitboard>0 do begin
                    // init source square
                    source_square := TBoard_squares(get_ls1b_index(bitboard));
                    source_squareInt:=integer(source_square);
                    // init target square
                    target_square :=TBoard_squares(source_squareInt - 8);
                    target_squareInt:=integer(target_square);
                    // generate quite pawn moves
                    if((not(target_square < a8)) and (get_bit(occupancies_3[both], target_squareInt)=0)) then begin
                        // pawn promotion
                        if (source_square >= a7) and (source_square <= h7) then begin
                            add_move^.move[count_move]:=encode_move(source_square, target_square, piece, integer(Q_), 0, 0, 0, 0);
                            Inc(count_move);
                            add_move^.move[count_move]:=encode_move(source_square, target_square, piece, integer(R_), 0, 0, 0, 0);
                            Inc(count_move);
                            add_move^.move[count_move]:=encode_move(source_square, target_square, piece, integer(B_), 0, 0, 0, 0);
                            Inc(count_move);
                            add_move^.move[count_move]:=encode_move(source_square, target_square, piece, integer(N_), 0, 0, 0, 0);
                            Inc(count_move);
                        end else begin
                           // one square ahead pawn move
                           add_move^.move[count_move]:=encode_move(source_square, target_square, piece, 0, 0, 0, 0, 0);
                           Inc(count_move);
                             // two squares ahead pawn move
                             if ((source_square >= a2) and (source_square <= h2) and (get_bit(occupancies_3[both], target_squareInt-8)=0) ) then  begin
                                add_move^.move[count_move]:=encode_move(source_square, TBoard_squares(target_squareInt - 8), piece, 0, 0, 1, 0, 0);
                                Inc(count_move);
                             end;
                        end;//if
                    end;//if
               // init pawn attacks bitboard
               attacks := pawn_attacks[side][source_square] and occupancies_3[black];
               // generate pawn captures
               while attacks>0 do begin
                        // init target square
                        target_square := TBoard_squares(get_ls1b_index(attacks));
                        target_squareInt:=integer(target_square);
                        // pawn promotion
                        if (source_square >= a7) and (source_square <= h7) then begin
                            add_move^.move[count_move]:=encode_move(source_square, target_square, piece, integer(Q_), 1, 0, 0, 0);
                            Inc(count_move);
                            add_move^.move[count_move]:=encode_move(source_square, target_square, piece, integer(R_), 1, 0, 0, 0);
                            Inc(count_move);
                            add_move^.move[count_move]:=encode_move(source_square, target_square, piece, integer(B_), 1, 0, 0, 0);
                            Inc(count_move);
                            add_move^.move[count_move]:=encode_move(source_square, target_square, piece, integer(N_), 1, 0, 0, 0);
                            Inc(count_move);
                        end else begin
                        // one square ahead pawn move
                            add_move^.move[count_move]:=encode_move(source_square, target_square, piece, 0, 1, 0, 0, 0);
                            Inc(count_move);
                        end;
                        // pop ls1b of the pawn attacks
                        pop_bit(attacks, target_square);
               end;//while attacks>0
               // generate enpassant captures
               if enpassantInt<>-1 then begin
                  // lookup pawn attacks and bitwise AND with enpassant square (bit)
                  enpassant_attacks := pawn_attacks[side][source_square] and (n1 shl enpassantInt);
                  if enpassant_attacks>0 then begin
                      // init enpassant capture target square
                      target_enpassantInt := get_ls1b_index(enpassant_attacks);
                      add_move^.move[count_move]:=encode_move(source_square, TBoard_squares(target_enpassantInt), piece, 0, 1, 0, 1, 0);
                      Inc(count_move);
                  end;
               end;//if enpassantInt<>-1
               // pop ls1b from piece bitboard copy
               pop_bit(bitboard, source_square);
               end;//while bitboard>0
            end;//if piece = P_
            //---------piece = P_-------------
            //---------piece = K_-------------
            // castling moves
            if (piece = K_) then begin
               // king side castling is available
               if (castle and integer(Tcastling(wk)))>0 then begin
                 // make sure square between king and king's rook are empty
                 if (get_bit(occupancies_3[both], integer(f1))=0) and (get_bit(occupancies_3[both], integer(g1))=0) then  begin
                    // make sure king and the f1 squares are not under attacks
                    if (is_square_attacked(e1, black)=0) and (is_square_attacked(f1, black)=0) then begin
                            add_move^.move[count_move]:=encode_move(e1, g1, piece, 0, 0, 0, 0, 1);
                            Inc(count_move);
                    end;
                 end;
               end;
               // queen side castling is available
               if (castle and integer(Tcastling(wq)))>0 then begin
                 // make sure square between king and queen's rook are empty
                 if (get_bit(occupancies_3[both], integer(b1))=0) and (get_bit(occupancies_3[both], integer(c1))=0) and (get_bit(occupancies_3[both], integer(d1))=0) then  begin
                    // make sure king and the f1 squares are not under attacks
                    if (is_square_attacked(e1, black)=0) and (is_square_attacked(d1, black)=0) then  begin
                            add_move^.move[count_move]:=encode_move(e1, c1, piece, 0, 0, 0, 0, 1);
                            Inc(count_move);
                    end;
                 end;
               end;
            end;//if piece = K_
            //---------piece = K_-------------
        end//if side = white
        else  begin
            //---------piece = p-------------
           // pick up black pawn bitboards index
            if (piece = p) then begin
               // loop over black pawns within black pawn bitboard
               while bitboard>0 do begin
                    // init source square
                    source_square := TBoard_squares(get_ls1b_index(bitboard));
                    source_squareInt:=integer(source_square);
                    // init target square
                    target_square :=TBoard_squares(source_squareInt + 8);
                    target_squareInt:=integer(target_square);
                    //--------------------------
                    // generate quite pawn moves
                    if((not(target_square > h1)) and (get_bit(occupancies_3[both], target_squareInt)=0)) then begin
                        // pawn promotion
                        if (source_square >= a2) and (source_square <= h2) then begin
                            add_move^.move[count_move]:=encode_move(source_square, target_square, piece, integer(q), 0, 0, 0, 0);
                            Inc(count_move);
                            add_move^.move[count_move]:=encode_move(source_square, target_square, piece, integer(r), 0, 0, 0, 0);
                            Inc(count_move);
                            add_move^.move[count_move]:=encode_move(source_square, target_square, piece, integer(b), 0, 0, 0, 0);
                            Inc(count_move);
                            add_move^.move[count_move]:=encode_move(source_square, target_square, piece, integer(n), 0, 0, 0, 0);
                            Inc(count_move);
                        end else begin
                           // one square ahead pawn move
                           add_move^.move[count_move]:=encode_move(source_square, target_square, piece, 0, 0, 0, 0, 0);
                           Inc(count_move);
                             // two squares ahead pawn move
                             if ((source_square >= a7) and (source_square <= h7) and (get_bit(occupancies_3[both], target_squareInt+8)=0) ) then  begin
                                add_move^.move[count_move]:=encode_move(source_square, TBoard_squares(target_squareInt + 8), piece, 0, 0, 1, 0, 0);
                                Inc(count_move);
                             end;
                        end;//if
                    end;//if
                    //--------------------------
                    // init pawn attacks bitboard
               attacks := pawn_attacks[side][source_square] and occupancies_3[white];
               // generate pawn captures
               while attacks>0 do begin
                        // init target square
                        target_square := TBoard_squares(get_ls1b_index(attacks));
                        target_squareInt:=integer(target_square);
                        // pawn promotion
                        if (source_square >= a2) and (source_square <= h2) then begin
                            add_move^.move[count_move]:=encode_move(source_square, target_square, piece, integer(q), 1, 0, 0, 0);
                            Inc(count_move);
                            add_move^.move[count_move]:=encode_move(source_square, target_square, piece, integer(r), 1, 0, 0, 0);
                            Inc(count_move);
                            add_move^.move[count_move]:=encode_move(source_square, target_square, piece, integer(b), 1, 0, 0, 0);
                            Inc(count_move);
                            add_move^.move[count_move]:=encode_move(source_square, target_square, piece, integer(n), 1, 0, 0, 0);
                            Inc(count_move);
                        end else begin
                        // one square ahead pawn move
                            add_move^.move[count_move]:=encode_move(source_square, target_square, piece, 0, 1, 0, 0, 0);
                            Inc(count_move);
                        end;
                        // pop ls1b of the pawn attacks
                        pop_bit(attacks, target_square);
               end;//while attacks>0
               //--------------------------
               // generate enpassant captures
               if enpassantInt<>-1 then begin
                  // lookup pawn attacks and bitwise AND with enpassant square (bit)
                  enpassant_attacks := pawn_attacks[side][source_square] and (n1 shl enpassantInt);
                  if enpassant_attacks>0 then begin
                      // init enpassant capture target square
                      target_enpassantInt := get_ls1b_index(enpassant_attacks);
                      add_move^.move[count_move]:=encode_move(source_square, TBoard_squares(target_enpassantInt), piece, 0, 1, 0, 1, 0);
                      Inc(count_move);
                  end;
               end;//if enpassantInt<>-1
               //--------------------------
               // pop ls1b from piece bitboard copy
               pop_bit(bitboard, source_square);
               end;//while bitboard>0
            end;//if piece = p
            //---------piece = p-------------
            //---------piece = k-------------
            // castling moves
            if (piece = k) then begin
               // king side castling is available
               if (castle and integer(Tcastling(bk)))>0 then begin
                 // make sure square between king and king's rook are empty
                 if (get_bit(occupancies_3[both], integer(f8))=0) and (get_bit(occupancies_3[both], integer(g8))=0) then  begin
                    // make sure king and the f1 squares are not under attacks
                    if (is_square_attacked(e8, white)=0) and (is_square_attacked(f8, white)=0) then begin 
                            add_move^.move[count_move]:=encode_move(e8, g8, piece, 0, 0, 0, 0, 1);
                            Inc(count_move);
                    end;
                 end;
               end;
               // queen side castling is available
               if (castle and integer(Tcastling(bq)))>0 then begin
                 // make sure square between king and queen's rook are empty
                 if (get_bit(occupancies_3[both], integer(b8))=0) and (get_bit(occupancies_3[both], integer(c8))=0) and (get_bit(occupancies_3[both], integer(d8))=0) then  begin
                    // make sure king and the f1 squares are not under attacks
                    if (is_square_attacked(e8, white)=0) and (is_square_attacked(d8, white)=0) then begin 
                            add_move^.move[count_move]:=encode_move(e8, c8, piece, 0, 0, 0, 0, 1);
                            Inc(count_move);
                    end;
                 end;
               end;
            end;//if piece = k
            //---------piece = k-------------
        end;//else - if (side = white)
        //--------------------------
        // genarate knight moves
        if ((side = white) and (piece = N_)) or ((side = black) and (piece = n))then begin
           // loop over source squares of piece bitboard copy
           while bitboard>0 do begin
              // init source square
              source_square := TBoard_squares(get_ls1b_index(bitboard));
              source_squareInt:=integer(source_square);
              // init piece attacks in order to get set of target squares
               attacks := knight_attacks[source_square] and (not(occupancies_3[side]));
               while attacks>0 do begin
                  // init target square
                  target_square := TBoard_squares(get_ls1b_index(attacks));
                  target_squareInt:=integer(target_square);
                  // quite move
                  if get_bit(occupancies_3[both], target_squareInt)=0 then begin 
                     add_move^.move[count_move]:=encode_move(source_square, target_square, piece, 0, 0, 0, 0, 0);
                     Inc(count_move);
                  end
                  // capture move
                     else begin 
                     add_move^.move[count_move]:=encode_move(source_square, target_square, piece, 0, 1, 0, 0, 0);
                     Inc(count_move);
                     end;
                  // pop ls1b of the pawn attacks
                  pop_bit(attacks, target_square);
               end;
              // pop ls1b from piece bitboard copy
              pop_bit(bitboard, source_square);
           end;
        end;//knight
        //--------------------------
        // generate bishop moves
        if ((side = white) and (piece = B_)) or ((side = black) and (piece = b))then begin
           // loop over source squares of piece bitboard copy
           while bitboard>0 do begin
              // init source square
              source_square := TBoard_squares(get_ls1b_index(bitboard));
              source_squareInt:=integer(source_square);
              // init piece attacks in order to get set of target squares
               attacks := get_bishop_attacks(source_square, occupancies_3[both]) and (not(occupancies_3[side]));
               while attacks>0 do begin
                  // init target square
                  target_square := TBoard_squares(get_ls1b_index(attacks));
                  target_squareInt:=integer(target_square);
                  // quite move
                  if get_bit(occupancies_3[both], target_squareInt)=0 then begin  
                     add_move^.move[count_move]:=encode_move(source_square, target_square, piece, 0, 0, 0, 0, 0);
                     Inc(count_move);
                  end
                  // capture move
                     else begin    
                     add_move^.move[count_move]:=encode_move(source_square, target_square, piece, 0, 1, 0, 0, 0);
                     Inc(count_move);
                     end;
                  // pop ls1b of the pawn attacks
                  pop_bit(attacks, target_square);
               end;
              // pop ls1b from piece bitboard copy
              pop_bit(bitboard, source_square);
           end;
        end;//bishop
        //--------------------------
        // generate rook moves
        if ((side = white) and (piece = R_)) or ((side = black) and (piece = r))then begin
           // loop over source squares of piece bitboard copy
           while bitboard>0 do begin
              // init source square
              source_square := TBoard_squares(get_ls1b_index(bitboard));
              source_squareInt:=integer(source_square);
              // init piece attacks in order to get set of target squares
               attacks := get_rook_attacks(source_square, occupancies_3[both]) and (not(occupancies_3[side]));
               while attacks>0 do begin
                  // init target square
                  target_square := TBoard_squares(get_ls1b_index(attacks));
                  target_squareInt:=integer(target_square);
                  // quite move
                  if get_bit(occupancies_3[both], target_squareInt)=0 then begin     
                     add_move^.move[count_move]:=encode_move(source_square, target_square, piece, 0, 0, 0, 0, 0);
                     Inc(count_move);
                  end
                  // capture move
                     else begin    
                     add_move^.move[count_move]:=encode_move(source_square, target_square, piece, 0, 1, 0, 0, 0);
                     Inc(count_move);
                     end;
                  // pop ls1b of the pawn attacks
                  pop_bit(attacks, target_square);
               end;
              // pop ls1b from piece bitboard copy
              pop_bit(bitboard, source_square);
           end;
        end;//rook
        //--------------------------
        // generate queen moves
        if ((side = white) and (piece = Q_)) or ((side = black) and (piece = q))then begin
           // loop over source squares of piece bitboard copy
           while bitboard>0 do begin
              // init source square
              source_square := TBoard_squares(get_ls1b_index(bitboard));
              source_squareInt:=integer(source_square);
              // init piece attacks in order to get set of target squares
               attacks := get_queen_attacks(source_square, occupancies_3[both]) and (not(occupancies_3[side]));
               while attacks>0 do begin
                  // init target square
                  target_square := TBoard_squares(get_ls1b_index(attacks));
                  target_squareInt:=integer(target_square);
                  // quite move
                  if get_bit(occupancies_3[both], target_squareInt)=0 then begin 
                     add_move^.move[count_move]:=encode_move(source_square, target_square, piece, 0, 0, 0, 0, 0);
                     Inc(count_move);
                  end
                  // capture move
                     else begin   
                     add_move^.move[count_move]:=encode_move(source_square, target_square, piece, 0, 1, 0, 0, 0);
                     Inc(count_move);
                     end;
                  // pop ls1b of the pawn attacks
                  pop_bit(attacks, target_square);
               end;
              // pop ls1b from piece bitboard copy
              pop_bit(bitboard, source_square);
           end;
        end;//queen
        //--------------------------
        // generate king moves
        if ((side = white) and (piece = K_)) or ((side = black) and (piece = k))then begin
           // loop over source squares of piece bitboard copy
           while bitboard>0 do begin
              // init source square
              source_square := TBoard_squares(get_ls1b_index(bitboard));
              source_squareInt:=integer(source_square);
              // init piece attacks in order to get set of target squares
               attacks := king_attacks[source_square] and (not(occupancies_3[side]));
               while attacks>0 do begin
                  // init target square
                  target_square := TBoard_squares(get_ls1b_index(attacks));
                  target_squareInt:=integer(target_square);
                  // quite move
                  if get_bit(occupancies_3[both], target_squareInt)=0 then begin 
                     add_move^.move[count_move]:=encode_move(source_square, target_square, piece, 0, 0, 0, 0, 0);
                     Inc(count_move);
                  end
                  // capture move
                     else begin   
                     add_move^.move[count_move]:=encode_move(source_square, target_square, piece, 0, 1, 0, 0, 0);
                     Inc(count_move);
                     end;
                  // pop ls1b of the pawn attacks
                  pop_bit(attacks, target_square);
               end;
              // pop ls1b from piece bitboard copy
              pop_bit(bitboard, source_square);
           end;
        end;//king
      end;//for
add_move^.count:=count_move;
end;
{/**********************************\
 ==================================

             Main driver

 ==================================
\**********************************/}

var
// create move
i:integer;
 begin
  //Переключение окна консоли на кодовую страницу CP1251 (Win-1251).
  //Если после переключения русские буквы показываются неверно,
  //следует открыть системное меню консольного окна - щелчком мыши в левом
  //верхнем углу окна консоли. И выбрать:
  //Свойства - закладка "Шрифт" - выбрать шрифт: "Lucida Console".
  SetConsoleCP(1251);
  SetConsoleOutputCP(1251);
 // SetConsoleOutputCP(CP_UTF8);
// ==================================
  // init all
  init_all();
  if parse_fen('r3k2r/p1ppqpb1/bn2pnp1/3PN3/1p2P3/2N2Q1p/PPPBBPPP/R3K2R w KQkq - 0 1 ')=false then Writeln('Ошибка FEN строки ...');
  print_board();
  //выделение памяти для нового списка ходов
  New(add_move);
  generate_moves();
  print_move_list();
  Dispose(add_move);
  Writeln('Нажмите <ENTER>, чтобы выйти ...');
  Readln;
end.

{/**********************************\
 ==================================

              Проверка работы функций

 ==================================
\**********************************/}
  //print_board();
  {
// FEN dedug positions
empty_board "8/8/8/8/8/8/8/8 w - - "
start_position "rnbqkbnr/pppppppp/8/8/8/8/PPPPPPPP/RNBQKBNR w KQkq - 0 1 "
tricky_position "r3k2r/p1ppqpb1/bn2pnp1/3PN3/1p2P3/2N2Q1p/PPPBBPPP/R3K2R w KQkq - 0 1 "
killer_position "rnbqkb1r/pp1p1pPp/8/2p1pP2/1P1P4/3P3P/P1P1P3/RNBQKBNR w KQkq e6 0 1"
cmk_position "r2q1rk1/ppp2ppp/2n1bn2/2b1p3/3pP3/3P1NPP/PPP1NPB1/R1BQ1RK1 b - - 0 9 "
}
{
  if parse_fen('r3k2r/p1ppqpb1/bn2pnp1/3PN3/1p2P3/2N2Q1p/PPPBBPPP/R3K2R w KQkq - 0 1 ')=false then Writeln('Ошибка FEN строки ...');
  print_board();
  generate_moves();

  set_bit(bitboards_12[p], a7); set_bit(bitboards_12[p], b7); set_bit(bitboards_12[p], c7);set_bit(bitboards_12[p], d7);
  set_bit(bitboards_12[p], e7); set_bit(bitboards_12[p], f7); set_bit(bitboards_12[p], g7);set_bit(bitboards_12[p], h7);
  set_bit(bitboards_12[r], a8);set_bit(bitboards_12[r], h8);set_bit(bitboards_12[n], b8);set_bit(bitboards_12[n], g8);
  set_bit(bitboards_12[b], c8);set_bit(bitboards_12[b], f8);set_bit(bitboards_12[q], d8);set_bit(bitboards_12[k], e8);
  set_bit(bitboards_12[P_], a2); set_bit(bitboards_12[P_], b2); set_bit(bitboards_12[P_], c2);set_bit(bitboards_12[P_], d2);
  set_bit(bitboards_12[P_], e2); set_bit(bitboards_12[P_], f2); set_bit(bitboards_12[P_], g2);set_bit(bitboards_12[P_], h2);
  set_bit(bitboards_12[R_], a1);set_bit(bitboards_12[R_], h1);set_bit(bitboards_12[N_], b1);set_bit(bitboards_12[N_], g1);
  set_bit(bitboards_12[B_], c1);set_bit(bitboards_12[B_], f1);set_bit(bitboards_12[Q_], d1);set_bit(bitboards_12[K_], e1);

      // init castling
      castle:=castle or integer(Tcastling(wk));
      castle:=castle or integer(Tcastling(wq));
      castle:=castle or integer(Tcastling(bk));
      castle:=castle or integer(Tcastling(bq));
   print_board();
        for piece := P_ to k do  begin
           print_bitboard(bitboards_12[piece]);
        end; }
               {
               piece:Tencode_pieces;
               for square := a8 to h1 do  begin
                 for piece := P_ to k do  begin
                 pop_bit(bitboards_12[piece],square);
                 end;
               end;
               }
  {print_bitboard(get_random_U32_number());
  print_bitboard(get_random_U32_number());
  print_bitboard(get_random_U64_number());
  print_bitboard(generate_magic_number());}

  {Writeln('bishop_relevant_bits');
  for square := a8 to h1 do  begin
    if (integer(square) mod 8)=0 then  Writeln('');
     Write(count_bits(mask_bishop_attacks(square))); Write(' ');
  end;
  Writeln('');
  Writeln('rook_relevant_bits');
    for square := a8 to h1 do  begin
    if (integer(square) mod 8)=0 then  Writeln('');
     Write(count_bits(mask_rook_attacks(square))); Write(' ');
  end;
  Writeln('');}

   { block:=4512464976740352;
  print_bitboard(block);
  square:=TBoard_squares(get_ls1b_index(block));
  Write('get_ls1b_index:',integer(square));
  Writeln('  coordinate:',square_to_coordinates[integer(square)]);
  set_bit(bitboard,square);
  print_bitboard(bitboard);}
  //ZobristKey[i][j][z]=rd.nextLong()^(rd.nextLong()<<15)^(rd.nextLong()<<30)^(rd.nextLong()<<45)^(rd.nextLong()<<60);
  //<< shl
  {
    // set blocker pieces on board
    set_bit(block, c5);
    set_bit(block, f2);
    set_bit(block, g7);
    set_bit(block, b2);
    set_bit(block, g5);
    set_bit(block, e2);
    set_bit(block, e7);
    print_bitboard(block);
      // print rook attacks
    print_bitboard(get_rook_attacks(e5, block));
    // print bishop attacks
    print_bitboard(get_bishop_attacks(d4, block));
  }
